function createSection() {
  const section = document.createElement('div');
  section.className = 'mirrorsharp-parts-section';
  return section;
}

export function renderPartTo(parent, part) {
  const span = document.createElement('span');
  span.className = 'cmt-' + part.kind;
  span.textContent = part.text;
  parent.appendChild(span);
}
export function renderPartsTo(parent, parts, {
  splitLinesToSections
} = {}) {
  let section = splitLinesToSections ? createSection() : parent;

  for (const part of parts) {
    if (part.kind === 'linebreak' && splitLinesToSections) {
      parent.appendChild(section);
      section = createSection();
      continue;
    }

    renderPartTo(section, part);
  }

  if (splitLinesToSections) parent.appendChild(section);
}
export function renderParts(parts, options = {}) {
  const container = document.createElement('div');
  renderPartsTo(container, parts, options);
  return container;
}